<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure/SmartDynamicArray/SmartDynamicArray.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_61f8caed08096df072032ac640f6feca.html">DataStructure</a></li><li class="navelem"><a class="el" href="dir_c5906fd827a922de9e18cb8f121642dc.html">SmartDynamicArray</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SmartDynamicArray.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="SmartDynamicArray_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef _SMART_DYNAMIC_ARRAY_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define _SMART_DYNAMIC_ARRAY_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// C++ Library includes</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// Project includes</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../Interfaces/ILinearDataStructure.h&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../../Utilities/StringUtil.h&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NotImplementedException.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/StructureFullException.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/StructureEmptyException.h&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/InvalidIndexException.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/ItemNotFoundException.h&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NullptrException.h&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceDataStructure.html">DataStructure</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html">   24</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray</a> : <span class="keyword">public</span> <a class="code" href="classDataStructure_1_1ILinearDataStructure.html">ILinearDataStructure</a>&lt;T&gt;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="comment">/* Public member methods */</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray</a>();</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        ~<a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray</a>();</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordtype">void</span> PushBack(T newItem);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordtype">void</span> PushFront(T newItem);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordtype">void</span> PushAt(T newItem, <span class="keywordtype">int</span> index);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keywordtype">void</span> PopBack();</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordtype">void</span> PopFront();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keywordtype">void</span> PopAt(<span class="keywordtype">int</span> index);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        T&amp; GetBack();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        T&amp; GetFront();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        T&amp; GetAt(<span class="keywordtype">int</span> index);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keywordtype">int</span> Search(T item) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">int</span> Size() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordtype">bool</span> IsEmpty() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordtype">void</span> Clear();</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="comment">/* Private member variables */</span></div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a885db4b7f48c3567c17bb7e2882c8674">   69</a></span>&#160;        T* <a class="code" href="classDataStructure_1_1SmartDynamicArray.html#a885db4b7f48c3567c17bb7e2882c8674">m_array</a>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a3f235a7fb7b75637f6d41d55191d6380">   72</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html#a3f235a7fb7b75637f6d41d55191d6380">m_arraySize</a>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#ac26160db30d9167fa36ff51052bb752f">   75</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html#ac26160db30d9167fa36ff51052bb752f">m_itemCount</a>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="comment">/* Private member methods */</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordtype">void</span> ShiftLeft(<span class="keywordtype">int</span> index);</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordtype">void</span> ShiftRight(<span class="keywordtype">int</span> index);</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordtype">void</span> AllocateMemory(<span class="keywordtype">int</span> size);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordtype">void</span> Resize(<span class="keywordtype">int</span> newSize);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">bool</span> IsFull() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a5a938b32fd11de6ea9e106b600672383">   91</a></span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1SmartDynamicArrayTester.html">SmartDynamicArrayTester</a>;</div>
<div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a09e5530081c238d8d84fbcef927c3937">   92</a></span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span>QueueTester;</div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a2118df8846e43115775918f6749561cf">   93</a></span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span>StackTester;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    };</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a1eb09bc31ee192471d5bfb0e9c714c21">  101</a></span>&#160;    <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::SmartDynamicArray</a>()</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        m_array = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        Clear();</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a9b3f819f6a20fb6b470ba482a1b86c55">  111</a></span>&#160;    <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::~SmartDynamicArray</a>()</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    {</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        Clear();</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a5b644f2ad10b357f0159b06bca1be73d">  125</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::Clear</a>()</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    {</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">if</span> (m_array != <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="keyword">delete</span>[] m_array;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            m_array = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        m_arraySize = 0;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        m_itemCount = 0;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    }</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#adde53eaea043a0a41d235bc0b8dbfd60">  140</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::Size</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">return</span> m_itemCount;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#ab30ac3eacd8ad8213aed6c318f5ac92c">  151</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::IsFull</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">return</span> (m_itemCount == m_arraySize);</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    }</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a426fef927621111c1be401c7fa73fe04">  163</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::IsEmpty</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="comment">//    throw NotImplementedException( &quot;SmartDynamicArray&lt;T&gt;::IsEmpty&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="keywordflow">return</span> (m_itemCount == 0);</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    }</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#aaa3754805deadf66c8ea5e3a41a0dcf3">  182</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::AllocateMemory</a>(<span class="keywordtype">int</span> size)</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    {</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::AllocateMemory&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    }</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00203"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a366c32288a8d737f762aaea323fabf9a">  203</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::Resize</a>(<span class="keywordtype">int</span> newSize)</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    {</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::Resize&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160; </div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00225"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#abaefb9b7811c66fd518c4af253d54ccf">  225</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::ShiftLeft</a>(<span class="keywordtype">int</span> index)</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    {</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::ShiftLeft&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    }</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160; </div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00249"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a56d8166117f4affe623c022e70b9370a">  249</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::ShiftRight</a>(<span class="keywordtype">int</span> index)</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    {</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::ShiftRight&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    }</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160; </div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00266"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a44cb3444992367a35d20709d3060f9a0">  266</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PushBack</a>(T newItem)</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    {</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PushBack&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    }</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00284"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a9daad437cfb07658035fb8eefba9980e">  284</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PushFront</a>(T newItem)</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    {</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PushFront&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    }</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160; </div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00307"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a972caa1466e5c7a447c4890cfe5ff71c">  307</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PushAt</a>(T newItem, <span class="keywordtype">int</span> index)</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    {</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PushAt&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    }</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160; </div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00321"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a5dd233281c39bde8f886ef0658466a29">  321</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PopBack</a>()</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    {</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PopBack&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    }</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160; </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00336"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a2b327554f75cb1ae6a149804de8d94ad">  336</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PopFront</a>()</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    {</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PopFront&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    }</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160; </div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00353"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a57a5d4f356b91b24587be9418064ec85">  353</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::PopAt</a>(<span class="keywordtype">int</span> index)</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    {</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::PopAt&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    }</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160; </div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00366"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a1fefb845be39b085318ffce09be71364">  366</a></span>&#160;    T&amp; <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::GetBack</a>()</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    {</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::GetBack&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    }</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160; </div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00379"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a38e5261034d4ac6d3e1f3bcee500c805">  379</a></span>&#160;    T&amp; <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::GetFront</a>()</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    {</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::GetFront&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    }</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160; </div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00395"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#a7d331e5248c7fc4acd78a6b6bfaa948e">  395</a></span>&#160;    T&amp; <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::GetAt</a>(<span class="keywordtype">int</span> index)</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    {</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::GetAt&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    }</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160; </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00408"></a><span class="lineno"><a class="line" href="classDataStructure_1_1SmartDynamicArray.html#ab99071d06891fdefbfeda4243a0f7c38">  408</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1SmartDynamicArray.html">SmartDynamicArray&lt;T&gt;::Search</a>(T item)<span class="keyword"> const</span></div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; m_itemCount; i++)</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        {</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <span class="keywordflow">if</span> (m_array[i] == item)</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            {</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;                <span class="keywordflow">return</span> i;</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;            }</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        }</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1ItemNotFoundException.html">Exception::ItemNotFoundException</a>(<span class="stringliteral">&quot;SmartDynamicArray&lt;T&gt;::Search&quot;</span>, <span class="stringliteral">&quot;Could not find item!&quot;</span>);</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    }</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160; </div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;}</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassDataStructure_1_1SmartDynamicArrayTester_html"><div class="ttname"><a href="classDataStructure_1_1SmartDynamicArrayTester.html">DataStructure::SmartDynamicArrayTester</a></div><div class="ttdoc">TESTER for the SmartDynamicArray.</div><div class="ttdef"><b>Definition:</b> SmartDynamicArrayTester.h:23</div></div>
<div class="ttc" id="aclassDataStructure_1_1ILinearDataStructure_html"><div class="ttname"><a href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a></div><div class="ttdoc">An interface of methods that our linear data structures should have.</div><div class="ttdef"><b>Definition:</b> ILinearDataStructure.h:12</div></div>
<div class="ttc" id="aclassException_1_1ItemNotFoundException_html"><div class="ttname"><a href="classException_1_1ItemNotFoundException.html">Exception::ItemNotFoundException</a></div><div class="ttdoc">EXCEPTION for item not found in a structure.</div><div class="ttdef"><b>Definition:</b> ItemNotFoundException.h:12</div></div>
<div class="ttc" id="anamespaceDataStructure_html"><div class="ttname"><a href="namespaceDataStructure.html">DataStructure</a></div><div class="ttdef"><b>Definition:</b> ILinearDataStructure.h:7</div></div>
<div class="ttc" id="aclassException_1_1NotImplementedException_html"><div class="ttname"><a href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a></div><div class="ttdoc">EXCEPTION for when a function has not yet been implemented.</div><div class="ttdef"><b>Definition:</b> NotImplementedException.h:12</div></div>
<div class="ttc" id="aclassDataStructure_1_1SmartDynamicArray_html"><div class="ttname"><a href="classDataStructure_1_1SmartDynamicArray.html">DataStructure::SmartDynamicArray</a></div><div class="ttdoc">A data structure that wraps a dynamic array.</div><div class="ttdef"><b>Definition:</b> SmartDynamicArray.h:24</div></div>
<div class="ttc" id="aclassDataStructure_1_1SmartDynamicArray_html_a3f235a7fb7b75637f6d41d55191d6380"><div class="ttname"><a href="classDataStructure_1_1SmartDynamicArray.html#a3f235a7fb7b75637f6d41d55191d6380">DataStructure::SmartDynamicArray::m_arraySize</a></div><div class="ttdeci">int m_arraySize</div><div class="ttdoc">The current size of the array.</div><div class="ttdef"><b>Definition:</b> SmartDynamicArray.h:72</div></div>
<div class="ttc" id="aclassDataStructure_1_1SmartDynamicArray_html_a885db4b7f48c3567c17bb7e2882c8674"><div class="ttname"><a href="classDataStructure_1_1SmartDynamicArray.html#a885db4b7f48c3567c17bb7e2882c8674">DataStructure::SmartDynamicArray::m_array</a></div><div class="ttdeci">T * m_array</div><div class="ttdoc">The pointer used for the dynamic array.</div><div class="ttdef"><b>Definition:</b> SmartDynamicArray.h:69</div></div>
<div class="ttc" id="aclassDataStructure_1_1SmartDynamicArray_html_ac26160db30d9167fa36ff51052bb752f"><div class="ttname"><a href="classDataStructure_1_1SmartDynamicArray.html#ac26160db30d9167fa36ff51052bb752f">DataStructure::SmartDynamicArray::m_itemCount</a></div><div class="ttdeci">int m_itemCount</div><div class="ttdoc">The current amount of items inserted into the array.</div><div class="ttdef"><b>Definition:</b> SmartDynamicArray.h:75</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
